#include <iostream>
#include <fstream>
#include "image.h"
#include "image_fileinput.h"
#include "image_mesaoutput.h"
#include "image_funcs.h"
#include "canny.h"

using namespace std;
using namespace mimas;

int	main(int argc, char **argv)
{
  int retVal = 0;
  try {
  x11_display display;
  image_mesaoutput< unsigned char > window( &display );
  image<int> imagein, imageout;
  canny<int>	canny;

  ifstream file( "../images/stills/lena-512x512.pgm", ios::binary );
  file >> imagein;

  window << imagein << mimas::pause();

/*	for (int count=0; count<4; count++)
	{
		halfResolution(imagein);
		window << imagein << mimas::pause();
	}
*/
	canny.getEdges(imagein);
	window << imagein << mimas::pause();

	// Note that halfResolutionEdgePyramid() assumes white (255) on black (0) images
	// unlike halfResolution() above
	for (int count=0; count<4; count++)
	{
		halfResolutionEdgePyramidIt(imagein);
		window << imagein << mimas::pause();
	}
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
